#ifndef _H_7F64033E5E0E82D9EF52ED1D1F135A32_ModelCoefficients_DCPS_H_
#define _H_7F64033E5E0E82D9EF52ED1D1F135A32_ModelCoefficients_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ModelCoefficients_.h"


namespace pcl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ModelCoefficients_TypeSupportInterface;

            typedef ModelCoefficients_TypeSupportInterface * ModelCoefficients_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ModelCoefficients_TypeSupportInterface> ModelCoefficients_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ModelCoefficients_TypeSupportInterface> ModelCoefficients_TypeSupportInterface_out;


            class ModelCoefficients_DataWriter;

            typedef ModelCoefficients_DataWriter * ModelCoefficients_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ModelCoefficients_DataWriter> ModelCoefficients_DataWriter_var;
            typedef DDS_DCPSInterface_out < ModelCoefficients_DataWriter> ModelCoefficients_DataWriter_out;


            class ModelCoefficients_DataReader;

            typedef ModelCoefficients_DataReader * ModelCoefficients_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ModelCoefficients_DataReader> ModelCoefficients_DataReader_var;
            typedef DDS_DCPSInterface_out < ModelCoefficients_DataReader> ModelCoefficients_DataReader_out;


            class ModelCoefficients_DataReaderView;

            typedef ModelCoefficients_DataReaderView * ModelCoefficients_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ModelCoefficients_DataReaderView> ModelCoefficients_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ModelCoefficients_DataReaderView> ModelCoefficients_DataReaderView_out;

            struct ModelCoefficients_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ModelCoefficients_, struct ModelCoefficients_Seq_uniq_> ModelCoefficients_Seq;
            typedef DDS_DCPSSequence_var < ModelCoefficients_Seq> ModelCoefficients_Seq_var;
            typedef DDS_DCPSSequence_out < ModelCoefficients_Seq> ModelCoefficients_Seq_out;

            class  ModelCoefficients_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ModelCoefficients_TypeSupportInterface_ptr _ptr_type;
                typedef ModelCoefficients_TypeSupportInterface_var _var_type;

                static ModelCoefficients_TypeSupportInterface_ptr _duplicate (ModelCoefficients_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModelCoefficients_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ModelCoefficients_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModelCoefficients_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ModelCoefficients_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ModelCoefficients_TypeSupportInterface () {};
                ~ModelCoefficients_TypeSupportInterface () {};
            private:
                ModelCoefficients_TypeSupportInterface (const ModelCoefficients_TypeSupportInterface &);
                ModelCoefficients_TypeSupportInterface & operator = (const ModelCoefficients_TypeSupportInterface &);
            };

            class  ModelCoefficients_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ModelCoefficients_DataWriter_ptr _ptr_type;
                typedef ModelCoefficients_DataWriter_var _var_type;

                static ModelCoefficients_DataWriter_ptr _duplicate (ModelCoefficients_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModelCoefficients_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ModelCoefficients_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModelCoefficients_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ModelCoefficients_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ModelCoefficients_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ModelCoefficients_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ModelCoefficients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ModelCoefficients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ModelCoefficients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ModelCoefficients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ModelCoefficients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ModelCoefficients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ModelCoefficients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ModelCoefficients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ModelCoefficients_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ModelCoefficients_& instance_data) = 0;

            protected:
                ModelCoefficients_DataWriter () {};
                ~ModelCoefficients_DataWriter () {};
            private:
                ModelCoefficients_DataWriter (const ModelCoefficients_DataWriter &);
                ModelCoefficients_DataWriter & operator = (const ModelCoefficients_DataWriter &);
            };

            class  ModelCoefficients_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ModelCoefficients_DataReader_ptr _ptr_type;
                typedef ModelCoefficients_DataReader_var _var_type;

                static ModelCoefficients_DataReader_ptr _duplicate (ModelCoefficients_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModelCoefficients_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ModelCoefficients_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModelCoefficients_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ModelCoefficients_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ModelCoefficients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ModelCoefficients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ModelCoefficients_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ModelCoefficients_& instance) = 0;

            protected:
                ModelCoefficients_DataReader () {};
                ~ModelCoefficients_DataReader () {};
            private:
                ModelCoefficients_DataReader (const ModelCoefficients_DataReader &);
                ModelCoefficients_DataReader & operator = (const ModelCoefficients_DataReader &);
            };

            class  ModelCoefficients_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ModelCoefficients_DataReaderView_ptr _ptr_type;
                typedef ModelCoefficients_DataReaderView_var _var_type;

                static ModelCoefficients_DataReaderView_ptr _duplicate (ModelCoefficients_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ModelCoefficients_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ModelCoefficients_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ModelCoefficients_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ModelCoefficients_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ModelCoefficients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ModelCoefficients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ModelCoefficients_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ModelCoefficients_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ModelCoefficients_& instance) = 0;

            protected:
                ModelCoefficients_DataReaderView () {};
                ~ModelCoefficients_DataReaderView () {};
            private:
                ModelCoefficients_DataReaderView (const ModelCoefficients_DataReaderView &);
                ModelCoefficients_DataReaderView & operator = (const ModelCoefficients_DataReaderView &);
            };
        }

    }

}

#endif
