#ifndef _H_0F4A5ADE2F9ECD45168DA808D71992DD_PointIndices_DCPS_H_
#define _H_0F4A5ADE2F9ECD45168DA808D71992DD_PointIndices_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointIndices_.h"


namespace pcl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PointIndices_TypeSupportInterface;

            typedef PointIndices_TypeSupportInterface * PointIndices_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointIndices_TypeSupportInterface> PointIndices_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointIndices_TypeSupportInterface> PointIndices_TypeSupportInterface_out;


            class PointIndices_DataWriter;

            typedef PointIndices_DataWriter * PointIndices_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointIndices_DataWriter> PointIndices_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointIndices_DataWriter> PointIndices_DataWriter_out;


            class PointIndices_DataReader;

            typedef PointIndices_DataReader * PointIndices_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointIndices_DataReader> PointIndices_DataReader_var;
            typedef DDS_DCPSInterface_out < PointIndices_DataReader> PointIndices_DataReader_out;


            class PointIndices_DataReaderView;

            typedef PointIndices_DataReaderView * PointIndices_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointIndices_DataReaderView> PointIndices_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointIndices_DataReaderView> PointIndices_DataReaderView_out;

            struct PointIndices_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointIndices_, struct PointIndices_Seq_uniq_> PointIndices_Seq;
            typedef DDS_DCPSSequence_var < PointIndices_Seq> PointIndices_Seq_var;
            typedef DDS_DCPSSequence_out < PointIndices_Seq> PointIndices_Seq_out;

            class  PointIndices_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointIndices_TypeSupportInterface_ptr _ptr_type;
                typedef PointIndices_TypeSupportInterface_var _var_type;

                static PointIndices_TypeSupportInterface_ptr _duplicate (PointIndices_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointIndices_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointIndices_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointIndices_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointIndices_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointIndices_TypeSupportInterface () {};
                ~PointIndices_TypeSupportInterface () {};
            private:
                PointIndices_TypeSupportInterface (const PointIndices_TypeSupportInterface &);
                PointIndices_TypeSupportInterface & operator = (const PointIndices_TypeSupportInterface &);
            };

            class  PointIndices_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointIndices_DataWriter_ptr _ptr_type;
                typedef PointIndices_DataWriter_var _var_type;

                static PointIndices_DataWriter_ptr _duplicate (PointIndices_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointIndices_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointIndices_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointIndices_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointIndices_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointIndices_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointIndices_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointIndices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointIndices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointIndices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointIndices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointIndices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointIndices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointIndices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointIndices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointIndices_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointIndices_& instance_data) = 0;

            protected:
                PointIndices_DataWriter () {};
                ~PointIndices_DataWriter () {};
            private:
                PointIndices_DataWriter (const PointIndices_DataWriter &);
                PointIndices_DataWriter & operator = (const PointIndices_DataWriter &);
            };

            class  PointIndices_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointIndices_DataReader_ptr _ptr_type;
                typedef PointIndices_DataReader_var _var_type;

                static PointIndices_DataReader_ptr _duplicate (PointIndices_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointIndices_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointIndices_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointIndices_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointIndices_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointIndices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointIndices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointIndices_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointIndices_& instance) = 0;

            protected:
                PointIndices_DataReader () {};
                ~PointIndices_DataReader () {};
            private:
                PointIndices_DataReader (const PointIndices_DataReader &);
                PointIndices_DataReader & operator = (const PointIndices_DataReader &);
            };

            class  PointIndices_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointIndices_DataReaderView_ptr _ptr_type;
                typedef PointIndices_DataReaderView_var _var_type;

                static PointIndices_DataReaderView_ptr _duplicate (PointIndices_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointIndices_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointIndices_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointIndices_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointIndices_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointIndices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointIndices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointIndices_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointIndices_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointIndices_& instance) = 0;

            protected:
                PointIndices_DataReaderView () {};
                ~PointIndices_DataReaderView () {};
            private:
                PointIndices_DataReaderView (const PointIndices_DataReaderView &);
                PointIndices_DataReaderView & operator = (const PointIndices_DataReaderView &);
            };
        }

    }

}

#endif
