#ifndef _H_29C33042986E027179F63504BD9AC0B3_PolygonMesh_DCPS_H_
#define _H_29C33042986E027179F63504BD9AC0B3_PolygonMesh_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PolygonMesh_.h"


namespace pcl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PolygonMesh_TypeSupportInterface;

            typedef PolygonMesh_TypeSupportInterface * PolygonMesh_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PolygonMesh_TypeSupportInterface> PolygonMesh_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PolygonMesh_TypeSupportInterface> PolygonMesh_TypeSupportInterface_out;


            class PolygonMesh_DataWriter;

            typedef PolygonMesh_DataWriter * PolygonMesh_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PolygonMesh_DataWriter> PolygonMesh_DataWriter_var;
            typedef DDS_DCPSInterface_out < PolygonMesh_DataWriter> PolygonMesh_DataWriter_out;


            class PolygonMesh_DataReader;

            typedef PolygonMesh_DataReader * PolygonMesh_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PolygonMesh_DataReader> PolygonMesh_DataReader_var;
            typedef DDS_DCPSInterface_out < PolygonMesh_DataReader> PolygonMesh_DataReader_out;


            class PolygonMesh_DataReaderView;

            typedef PolygonMesh_DataReaderView * PolygonMesh_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PolygonMesh_DataReaderView> PolygonMesh_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PolygonMesh_DataReaderView> PolygonMesh_DataReaderView_out;

            struct PolygonMesh_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PolygonMesh_, struct PolygonMesh_Seq_uniq_> PolygonMesh_Seq;
            typedef DDS_DCPSSequence_var < PolygonMesh_Seq> PolygonMesh_Seq_var;
            typedef DDS_DCPSSequence_out < PolygonMesh_Seq> PolygonMesh_Seq_out;

            class  PolygonMesh_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PolygonMesh_TypeSupportInterface_ptr _ptr_type;
                typedef PolygonMesh_TypeSupportInterface_var _var_type;

                static PolygonMesh_TypeSupportInterface_ptr _duplicate (PolygonMesh_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PolygonMesh_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PolygonMesh_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PolygonMesh_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PolygonMesh_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PolygonMesh_TypeSupportInterface () {};
                ~PolygonMesh_TypeSupportInterface () {};
            private:
                PolygonMesh_TypeSupportInterface (const PolygonMesh_TypeSupportInterface &);
                PolygonMesh_TypeSupportInterface & operator = (const PolygonMesh_TypeSupportInterface &);
            };

            class  PolygonMesh_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PolygonMesh_DataWriter_ptr _ptr_type;
                typedef PolygonMesh_DataWriter_var _var_type;

                static PolygonMesh_DataWriter_ptr _duplicate (PolygonMesh_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PolygonMesh_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PolygonMesh_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PolygonMesh_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PolygonMesh_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PolygonMesh_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PolygonMesh_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PolygonMesh_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PolygonMesh_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PolygonMesh_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PolygonMesh_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PolygonMesh_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PolygonMesh_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PolygonMesh_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PolygonMesh_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PolygonMesh_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PolygonMesh_& instance_data) = 0;

            protected:
                PolygonMesh_DataWriter () {};
                ~PolygonMesh_DataWriter () {};
            private:
                PolygonMesh_DataWriter (const PolygonMesh_DataWriter &);
                PolygonMesh_DataWriter & operator = (const PolygonMesh_DataWriter &);
            };

            class  PolygonMesh_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PolygonMesh_DataReader_ptr _ptr_type;
                typedef PolygonMesh_DataReader_var _var_type;

                static PolygonMesh_DataReader_ptr _duplicate (PolygonMesh_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PolygonMesh_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PolygonMesh_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PolygonMesh_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PolygonMesh_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PolygonMesh_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PolygonMesh_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PolygonMesh_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PolygonMesh_& instance) = 0;

            protected:
                PolygonMesh_DataReader () {};
                ~PolygonMesh_DataReader () {};
            private:
                PolygonMesh_DataReader (const PolygonMesh_DataReader &);
                PolygonMesh_DataReader & operator = (const PolygonMesh_DataReader &);
            };

            class  PolygonMesh_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PolygonMesh_DataReaderView_ptr _ptr_type;
                typedef PolygonMesh_DataReaderView_var _var_type;

                static PolygonMesh_DataReaderView_ptr _duplicate (PolygonMesh_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PolygonMesh_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PolygonMesh_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PolygonMesh_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PolygonMesh_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PolygonMesh_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PolygonMesh_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PolygonMesh_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PolygonMesh_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PolygonMesh_& instance) = 0;

            protected:
                PolygonMesh_DataReaderView () {};
                ~PolygonMesh_DataReaderView () {};
            private:
                PolygonMesh_DataReaderView (const PolygonMesh_DataReaderView &);
                PolygonMesh_DataReaderView & operator = (const PolygonMesh_DataReaderView &);
            };
        }

    }

}

#endif
