#ifndef _H_A39B7F1AA14BA35D7EE77CC0AC667710_Vertices_DCPS_H_
#define _H_A39B7F1AA14BA35D7EE77CC0AC667710_Vertices_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Vertices_.h"


namespace pcl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Vertices_TypeSupportInterface;

            typedef Vertices_TypeSupportInterface * Vertices_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Vertices_TypeSupportInterface> Vertices_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Vertices_TypeSupportInterface> Vertices_TypeSupportInterface_out;


            class Vertices_DataWriter;

            typedef Vertices_DataWriter * Vertices_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Vertices_DataWriter> Vertices_DataWriter_var;
            typedef DDS_DCPSInterface_out < Vertices_DataWriter> Vertices_DataWriter_out;


            class Vertices_DataReader;

            typedef Vertices_DataReader * Vertices_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Vertices_DataReader> Vertices_DataReader_var;
            typedef DDS_DCPSInterface_out < Vertices_DataReader> Vertices_DataReader_out;


            class Vertices_DataReaderView;

            typedef Vertices_DataReaderView * Vertices_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Vertices_DataReaderView> Vertices_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Vertices_DataReaderView> Vertices_DataReaderView_out;

            struct Vertices_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Vertices_, struct Vertices_Seq_uniq_> Vertices_Seq;
            typedef DDS_DCPSSequence_var < Vertices_Seq> Vertices_Seq_var;
            typedef DDS_DCPSSequence_out < Vertices_Seq> Vertices_Seq_out;

            class  Vertices_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Vertices_TypeSupportInterface_ptr _ptr_type;
                typedef Vertices_TypeSupportInterface_var _var_type;

                static Vertices_TypeSupportInterface_ptr _duplicate (Vertices_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Vertices_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Vertices_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Vertices_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Vertices_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Vertices_TypeSupportInterface () {};
                ~Vertices_TypeSupportInterface () {};
            private:
                Vertices_TypeSupportInterface (const Vertices_TypeSupportInterface &);
                Vertices_TypeSupportInterface & operator = (const Vertices_TypeSupportInterface &);
            };

            class  Vertices_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Vertices_DataWriter_ptr _ptr_type;
                typedef Vertices_DataWriter_var _var_type;

                static Vertices_DataWriter_ptr _duplicate (Vertices_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Vertices_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Vertices_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Vertices_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Vertices_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Vertices_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Vertices_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Vertices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Vertices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Vertices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Vertices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Vertices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Vertices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Vertices_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Vertices_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Vertices_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Vertices_& instance_data) = 0;

            protected:
                Vertices_DataWriter () {};
                ~Vertices_DataWriter () {};
            private:
                Vertices_DataWriter (const Vertices_DataWriter &);
                Vertices_DataWriter & operator = (const Vertices_DataWriter &);
            };

            class  Vertices_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Vertices_DataReader_ptr _ptr_type;
                typedef Vertices_DataReader_var _var_type;

                static Vertices_DataReader_ptr _duplicate (Vertices_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Vertices_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Vertices_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Vertices_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Vertices_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Vertices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Vertices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Vertices_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Vertices_& instance) = 0;

            protected:
                Vertices_DataReader () {};
                ~Vertices_DataReader () {};
            private:
                Vertices_DataReader (const Vertices_DataReader &);
                Vertices_DataReader & operator = (const Vertices_DataReader &);
            };

            class  Vertices_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Vertices_DataReaderView_ptr _ptr_type;
                typedef Vertices_DataReaderView_var _var_type;

                static Vertices_DataReaderView_ptr _duplicate (Vertices_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Vertices_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Vertices_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Vertices_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Vertices_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Vertices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Vertices_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Vertices_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Vertices_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Vertices_& instance) = 0;

            protected:
                Vertices_DataReaderView () {};
                ~Vertices_DataReaderView () {};
            private:
                Vertices_DataReaderView (const Vertices_DataReaderView &);
                Vertices_DataReaderView & operator = (const Vertices_DataReaderView &);
            };
        }

    }

}

#endif
