#ifndef _H_BE62459A35E47BF6B6A4693B5CA7B917_UpdateFilename__H_
#define _H_BE62459A35E47BF6B6A4693B5CA7B917_UpdateFilename__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace pcl_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  UpdateFilename_Request_
            {
                ::DDS::String_mgr filename_;
            };

            typedef DDS_DCPSStruct_var<UpdateFilename_Request_> UpdateFilename_Request__var;
            typedef DDS_DCPSStruct_out < UpdateFilename_Request_> UpdateFilename_Request__out;

            struct  UpdateFilename_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<UpdateFilename_Response_> UpdateFilename_Response__var;
            typedef UpdateFilename_Response_& UpdateFilename_Response__out;

            struct  Sample_UpdateFilename_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::pcl_msgs::srv::dds_::UpdateFilename_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_UpdateFilename_Request_> Sample_UpdateFilename_Request__var;
            typedef DDS_DCPSStruct_out < Sample_UpdateFilename_Request_> Sample_UpdateFilename_Request__out;

            struct  Sample_UpdateFilename_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::pcl_msgs::srv::dds_::UpdateFilename_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_UpdateFilename_Response_> Sample_UpdateFilename_Response__var;
            typedef Sample_UpdateFilename_Response_& Sample_UpdateFilename_Response__out;

        }

    }

}

#endif /* _H_BE62459A35E47BF6B6A4693B5CA7B917_UpdateFilename__H_ */
