#ifndef _H_BE62459A35E47BF6B6A4693B5CA7B917_UpdateFilename_DCPS_H_
#define _H_BE62459A35E47BF6B6A4693B5CA7B917_UpdateFilename_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UpdateFilename_.h"


namespace pcl_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class UpdateFilename_Request_TypeSupportInterface;

            typedef UpdateFilename_Request_TypeSupportInterface * UpdateFilename_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Request_TypeSupportInterface> UpdateFilename_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Request_TypeSupportInterface> UpdateFilename_Request_TypeSupportInterface_out;


            class UpdateFilename_Request_DataWriter;

            typedef UpdateFilename_Request_DataWriter * UpdateFilename_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Request_DataWriter> UpdateFilename_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Request_DataWriter> UpdateFilename_Request_DataWriter_out;


            class UpdateFilename_Request_DataReader;

            typedef UpdateFilename_Request_DataReader * UpdateFilename_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Request_DataReader> UpdateFilename_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Request_DataReader> UpdateFilename_Request_DataReader_out;


            class UpdateFilename_Request_DataReaderView;

            typedef UpdateFilename_Request_DataReaderView * UpdateFilename_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Request_DataReaderView> UpdateFilename_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Request_DataReaderView> UpdateFilename_Request_DataReaderView_out;

            struct UpdateFilename_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UpdateFilename_Request_, struct UpdateFilename_Request_Seq_uniq_> UpdateFilename_Request_Seq;
            typedef DDS_DCPSSequence_var < UpdateFilename_Request_Seq> UpdateFilename_Request_Seq_var;
            typedef DDS_DCPSSequence_out < UpdateFilename_Request_Seq> UpdateFilename_Request_Seq_out;

            class  UpdateFilename_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UpdateFilename_Request_TypeSupportInterface_ptr _ptr_type;
                typedef UpdateFilename_Request_TypeSupportInterface_var _var_type;

                static UpdateFilename_Request_TypeSupportInterface_ptr _duplicate (UpdateFilename_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UpdateFilename_Request_TypeSupportInterface () {};
                ~UpdateFilename_Request_TypeSupportInterface () {};
            private:
                UpdateFilename_Request_TypeSupportInterface (const UpdateFilename_Request_TypeSupportInterface &);
                UpdateFilename_Request_TypeSupportInterface & operator = (const UpdateFilename_Request_TypeSupportInterface &);
            };

            class  UpdateFilename_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UpdateFilename_Request_DataWriter_ptr _ptr_type;
                typedef UpdateFilename_Request_DataWriter_var _var_type;

                static UpdateFilename_Request_DataWriter_ptr _duplicate (UpdateFilename_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UpdateFilename_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UpdateFilename_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UpdateFilename_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateFilename_Request_& instance_data) = 0;

            protected:
                UpdateFilename_Request_DataWriter () {};
                ~UpdateFilename_Request_DataWriter () {};
            private:
                UpdateFilename_Request_DataWriter (const UpdateFilename_Request_DataWriter &);
                UpdateFilename_Request_DataWriter & operator = (const UpdateFilename_Request_DataWriter &);
            };

            class  UpdateFilename_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UpdateFilename_Request_DataReader_ptr _ptr_type;
                typedef UpdateFilename_Request_DataReader_var _var_type;

                static UpdateFilename_Request_DataReader_ptr _duplicate (UpdateFilename_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateFilename_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateFilename_Request_& instance) = 0;

            protected:
                UpdateFilename_Request_DataReader () {};
                ~UpdateFilename_Request_DataReader () {};
            private:
                UpdateFilename_Request_DataReader (const UpdateFilename_Request_DataReader &);
                UpdateFilename_Request_DataReader & operator = (const UpdateFilename_Request_DataReader &);
            };

            class  UpdateFilename_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UpdateFilename_Request_DataReaderView_ptr _ptr_type;
                typedef UpdateFilename_Request_DataReaderView_var _var_type;

                static UpdateFilename_Request_DataReaderView_ptr _duplicate (UpdateFilename_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateFilename_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateFilename_Request_& instance) = 0;

            protected:
                UpdateFilename_Request_DataReaderView () {};
                ~UpdateFilename_Request_DataReaderView () {};
            private:
                UpdateFilename_Request_DataReaderView (const UpdateFilename_Request_DataReaderView &);
                UpdateFilename_Request_DataReaderView & operator = (const UpdateFilename_Request_DataReaderView &);
            };
            class UpdateFilename_Response_TypeSupportInterface;

            typedef UpdateFilename_Response_TypeSupportInterface * UpdateFilename_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Response_TypeSupportInterface> UpdateFilename_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Response_TypeSupportInterface> UpdateFilename_Response_TypeSupportInterface_out;


            class UpdateFilename_Response_DataWriter;

            typedef UpdateFilename_Response_DataWriter * UpdateFilename_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Response_DataWriter> UpdateFilename_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Response_DataWriter> UpdateFilename_Response_DataWriter_out;


            class UpdateFilename_Response_DataReader;

            typedef UpdateFilename_Response_DataReader * UpdateFilename_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Response_DataReader> UpdateFilename_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Response_DataReader> UpdateFilename_Response_DataReader_out;


            class UpdateFilename_Response_DataReaderView;

            typedef UpdateFilename_Response_DataReaderView * UpdateFilename_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UpdateFilename_Response_DataReaderView> UpdateFilename_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UpdateFilename_Response_DataReaderView> UpdateFilename_Response_DataReaderView_out;

            struct UpdateFilename_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < UpdateFilename_Response_, struct UpdateFilename_Response_Seq_uniq_> UpdateFilename_Response_Seq;
            typedef DDS_DCPSSequence_var < UpdateFilename_Response_Seq> UpdateFilename_Response_Seq_var;
            typedef DDS_DCPSSequence_out < UpdateFilename_Response_Seq> UpdateFilename_Response_Seq_out;

            class  UpdateFilename_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UpdateFilename_Response_TypeSupportInterface_ptr _ptr_type;
                typedef UpdateFilename_Response_TypeSupportInterface_var _var_type;

                static UpdateFilename_Response_TypeSupportInterface_ptr _duplicate (UpdateFilename_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UpdateFilename_Response_TypeSupportInterface () {};
                ~UpdateFilename_Response_TypeSupportInterface () {};
            private:
                UpdateFilename_Response_TypeSupportInterface (const UpdateFilename_Response_TypeSupportInterface &);
                UpdateFilename_Response_TypeSupportInterface & operator = (const UpdateFilename_Response_TypeSupportInterface &);
            };

            class  UpdateFilename_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UpdateFilename_Response_DataWriter_ptr _ptr_type;
                typedef UpdateFilename_Response_DataWriter_var _var_type;

                static UpdateFilename_Response_DataWriter_ptr _duplicate (UpdateFilename_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UpdateFilename_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UpdateFilename_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UpdateFilename_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateFilename_Response_& instance_data) = 0;

            protected:
                UpdateFilename_Response_DataWriter () {};
                ~UpdateFilename_Response_DataWriter () {};
            private:
                UpdateFilename_Response_DataWriter (const UpdateFilename_Response_DataWriter &);
                UpdateFilename_Response_DataWriter & operator = (const UpdateFilename_Response_DataWriter &);
            };

            class  UpdateFilename_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UpdateFilename_Response_DataReader_ptr _ptr_type;
                typedef UpdateFilename_Response_DataReader_var _var_type;

                static UpdateFilename_Response_DataReader_ptr _duplicate (UpdateFilename_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateFilename_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateFilename_Response_& instance) = 0;

            protected:
                UpdateFilename_Response_DataReader () {};
                ~UpdateFilename_Response_DataReader () {};
            private:
                UpdateFilename_Response_DataReader (const UpdateFilename_Response_DataReader &);
                UpdateFilename_Response_DataReader & operator = (const UpdateFilename_Response_DataReader &);
            };

            class  UpdateFilename_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UpdateFilename_Response_DataReaderView_ptr _ptr_type;
                typedef UpdateFilename_Response_DataReaderView_var _var_type;

                static UpdateFilename_Response_DataReaderView_ptr _duplicate (UpdateFilename_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UpdateFilename_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UpdateFilename_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UpdateFilename_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UpdateFilename_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UpdateFilename_Response_& instance) = 0;

            protected:
                UpdateFilename_Response_DataReaderView () {};
                ~UpdateFilename_Response_DataReaderView () {};
            private:
                UpdateFilename_Response_DataReaderView (const UpdateFilename_Response_DataReaderView &);
                UpdateFilename_Response_DataReaderView & operator = (const UpdateFilename_Response_DataReaderView &);
            };
            class Sample_UpdateFilename_Request_TypeSupportInterface;

            typedef Sample_UpdateFilename_Request_TypeSupportInterface * Sample_UpdateFilename_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Request_TypeSupportInterface> Sample_UpdateFilename_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Request_TypeSupportInterface> Sample_UpdateFilename_Request_TypeSupportInterface_out;


            class Sample_UpdateFilename_Request_DataWriter;

            typedef Sample_UpdateFilename_Request_DataWriter * Sample_UpdateFilename_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Request_DataWriter> Sample_UpdateFilename_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Request_DataWriter> Sample_UpdateFilename_Request_DataWriter_out;


            class Sample_UpdateFilename_Request_DataReader;

            typedef Sample_UpdateFilename_Request_DataReader * Sample_UpdateFilename_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Request_DataReader> Sample_UpdateFilename_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Request_DataReader> Sample_UpdateFilename_Request_DataReader_out;


            class Sample_UpdateFilename_Request_DataReaderView;

            typedef Sample_UpdateFilename_Request_DataReaderView * Sample_UpdateFilename_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Request_DataReaderView> Sample_UpdateFilename_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Request_DataReaderView> Sample_UpdateFilename_Request_DataReaderView_out;

            struct Sample_UpdateFilename_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_UpdateFilename_Request_, struct Sample_UpdateFilename_Request_Seq_uniq_> Sample_UpdateFilename_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_UpdateFilename_Request_Seq> Sample_UpdateFilename_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UpdateFilename_Request_Seq> Sample_UpdateFilename_Request_Seq_out;

            class  Sample_UpdateFilename_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UpdateFilename_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UpdateFilename_Request_TypeSupportInterface_var _var_type;

                static Sample_UpdateFilename_Request_TypeSupportInterface_ptr _duplicate (Sample_UpdateFilename_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UpdateFilename_Request_TypeSupportInterface () {};
                ~Sample_UpdateFilename_Request_TypeSupportInterface () {};
            private:
                Sample_UpdateFilename_Request_TypeSupportInterface (const Sample_UpdateFilename_Request_TypeSupportInterface &);
                Sample_UpdateFilename_Request_TypeSupportInterface & operator = (const Sample_UpdateFilename_Request_TypeSupportInterface &);
            };

            class  Sample_UpdateFilename_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UpdateFilename_Request_DataWriter_ptr _ptr_type;
                typedef Sample_UpdateFilename_Request_DataWriter_var _var_type;

                static Sample_UpdateFilename_Request_DataWriter_ptr _duplicate (Sample_UpdateFilename_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UpdateFilename_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UpdateFilename_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UpdateFilename_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateFilename_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateFilename_Request_& instance_data) = 0;

            protected:
                Sample_UpdateFilename_Request_DataWriter () {};
                ~Sample_UpdateFilename_Request_DataWriter () {};
            private:
                Sample_UpdateFilename_Request_DataWriter (const Sample_UpdateFilename_Request_DataWriter &);
                Sample_UpdateFilename_Request_DataWriter & operator = (const Sample_UpdateFilename_Request_DataWriter &);
            };

            class  Sample_UpdateFilename_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UpdateFilename_Request_DataReader_ptr _ptr_type;
                typedef Sample_UpdateFilename_Request_DataReader_var _var_type;

                static Sample_UpdateFilename_Request_DataReader_ptr _duplicate (Sample_UpdateFilename_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateFilename_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateFilename_Request_& instance) = 0;

            protected:
                Sample_UpdateFilename_Request_DataReader () {};
                ~Sample_UpdateFilename_Request_DataReader () {};
            private:
                Sample_UpdateFilename_Request_DataReader (const Sample_UpdateFilename_Request_DataReader &);
                Sample_UpdateFilename_Request_DataReader & operator = (const Sample_UpdateFilename_Request_DataReader &);
            };

            class  Sample_UpdateFilename_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UpdateFilename_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_UpdateFilename_Request_DataReaderView_var _var_type;

                static Sample_UpdateFilename_Request_DataReaderView_ptr _duplicate (Sample_UpdateFilename_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateFilename_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateFilename_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateFilename_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateFilename_Request_& instance) = 0;

            protected:
                Sample_UpdateFilename_Request_DataReaderView () {};
                ~Sample_UpdateFilename_Request_DataReaderView () {};
            private:
                Sample_UpdateFilename_Request_DataReaderView (const Sample_UpdateFilename_Request_DataReaderView &);
                Sample_UpdateFilename_Request_DataReaderView & operator = (const Sample_UpdateFilename_Request_DataReaderView &);
            };
            class Sample_UpdateFilename_Response_TypeSupportInterface;

            typedef Sample_UpdateFilename_Response_TypeSupportInterface * Sample_UpdateFilename_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Response_TypeSupportInterface> Sample_UpdateFilename_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Response_TypeSupportInterface> Sample_UpdateFilename_Response_TypeSupportInterface_out;


            class Sample_UpdateFilename_Response_DataWriter;

            typedef Sample_UpdateFilename_Response_DataWriter * Sample_UpdateFilename_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Response_DataWriter> Sample_UpdateFilename_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Response_DataWriter> Sample_UpdateFilename_Response_DataWriter_out;


            class Sample_UpdateFilename_Response_DataReader;

            typedef Sample_UpdateFilename_Response_DataReader * Sample_UpdateFilename_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Response_DataReader> Sample_UpdateFilename_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Response_DataReader> Sample_UpdateFilename_Response_DataReader_out;


            class Sample_UpdateFilename_Response_DataReaderView;

            typedef Sample_UpdateFilename_Response_DataReaderView * Sample_UpdateFilename_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UpdateFilename_Response_DataReaderView> Sample_UpdateFilename_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UpdateFilename_Response_DataReaderView> Sample_UpdateFilename_Response_DataReaderView_out;

            struct Sample_UpdateFilename_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_UpdateFilename_Response_, struct Sample_UpdateFilename_Response_Seq_uniq_> Sample_UpdateFilename_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_UpdateFilename_Response_Seq> Sample_UpdateFilename_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UpdateFilename_Response_Seq> Sample_UpdateFilename_Response_Seq_out;

            class  Sample_UpdateFilename_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UpdateFilename_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UpdateFilename_Response_TypeSupportInterface_var _var_type;

                static Sample_UpdateFilename_Response_TypeSupportInterface_ptr _duplicate (Sample_UpdateFilename_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UpdateFilename_Response_TypeSupportInterface () {};
                ~Sample_UpdateFilename_Response_TypeSupportInterface () {};
            private:
                Sample_UpdateFilename_Response_TypeSupportInterface (const Sample_UpdateFilename_Response_TypeSupportInterface &);
                Sample_UpdateFilename_Response_TypeSupportInterface & operator = (const Sample_UpdateFilename_Response_TypeSupportInterface &);
            };

            class  Sample_UpdateFilename_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UpdateFilename_Response_DataWriter_ptr _ptr_type;
                typedef Sample_UpdateFilename_Response_DataWriter_var _var_type;

                static Sample_UpdateFilename_Response_DataWriter_ptr _duplicate (Sample_UpdateFilename_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UpdateFilename_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UpdateFilename_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UpdateFilename_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateFilename_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateFilename_Response_& instance_data) = 0;

            protected:
                Sample_UpdateFilename_Response_DataWriter () {};
                ~Sample_UpdateFilename_Response_DataWriter () {};
            private:
                Sample_UpdateFilename_Response_DataWriter (const Sample_UpdateFilename_Response_DataWriter &);
                Sample_UpdateFilename_Response_DataWriter & operator = (const Sample_UpdateFilename_Response_DataWriter &);
            };

            class  Sample_UpdateFilename_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UpdateFilename_Response_DataReader_ptr _ptr_type;
                typedef Sample_UpdateFilename_Response_DataReader_var _var_type;

                static Sample_UpdateFilename_Response_DataReader_ptr _duplicate (Sample_UpdateFilename_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateFilename_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateFilename_Response_& instance) = 0;

            protected:
                Sample_UpdateFilename_Response_DataReader () {};
                ~Sample_UpdateFilename_Response_DataReader () {};
            private:
                Sample_UpdateFilename_Response_DataReader (const Sample_UpdateFilename_Response_DataReader &);
                Sample_UpdateFilename_Response_DataReader & operator = (const Sample_UpdateFilename_Response_DataReader &);
            };

            class  Sample_UpdateFilename_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UpdateFilename_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_UpdateFilename_Response_DataReaderView_var _var_type;

                static Sample_UpdateFilename_Response_DataReaderView_ptr _duplicate (Sample_UpdateFilename_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UpdateFilename_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UpdateFilename_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UpdateFilename_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UpdateFilename_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UpdateFilename_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UpdateFilename_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UpdateFilename_Response_& instance) = 0;

            protected:
                Sample_UpdateFilename_Response_DataReaderView () {};
                ~Sample_UpdateFilename_Response_DataReaderView () {};
            private:
                Sample_UpdateFilename_Response_DataReaderView (const Sample_UpdateFilename_Response_DataReaderView &);
                Sample_UpdateFilename_Response_DataReaderView & operator = (const Sample_UpdateFilename_Response_DataReaderView &);
            };
        }

    }

}

#endif
